unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MkDs18x20, Vcl.StdCtrls,
  Vcl.Imaging.pngimage, Vcl.ExtCtrls, mk_usb_detector;

type
  TForm1 = class(TForm)
    MkDs18x20: TMkDs18x20;
    Image1: TImage;
    Label1: TLabel;
    ComboBox1: TComboBox;
    MkUsbDetector1: TMkUsbDetector;
    Button1: TButton;
    Timer1: TTimer;
    Label2: TLabel;
    procedure ComboBox1DropDown(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MkDs18x20GetSensorCount(Sender: TObject);
    procedure MkDs18x20GetTemp(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MkDs18x20SessionError(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  MkDs18x20.ComPort := ComboBox1.Text;
  if MkDs18x20.DriverActive then begin
    Label1.Caption := 'odczyt';
    MkDs18x20.TMEXGetDSCount;
  end else begin

    Showmessage('Brak zainstalowanego sterownika MAXIM - TMEX micro LAN');
  end;

end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items );
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Label1.Caption := 'czekaj';
  Screen.Cursor := crHourGlass;
  while MkDs18x20.Busy do
    Application.ProcessMessages;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items );
  ActiveControl := Button1;
end;

procedure TForm1.MkDs18x20GetSensorCount(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TForm1.MkDs18x20GetTemp(Sender: TObject);
begin
  Label1.Caption := MkDs18x20.sensor[0].temp+' '+char(176)+'C';
  Timer1.Enabled := True;
end;

procedure TForm1.MkDs18x20SessionError(Sender: TObject);
begin
  Label1.Caption := 'error';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  MkDs18x20.TMEXGetTemp;
end;

end.
