unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, MkDs18x20, System.ImageList, Shellapi,
  Vcl.ImgList, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, frmKomunikatU,
  mk_usb_detector;

const App_Reg_Key = 'Software\PomiarTemperatury';

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Panel3: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Image1: TImage;
    Label1: TLabel;
    ListView1: TListView;
    Timer1: TTimer;
    ImageList1: TImageList;
    StatusBar1: TStatusBar;
    MkDs18x20: TMkDs18x20;
    Label3a: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    MkUsbDetector1: TMkUsbDetector;
    Label2: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Button7: TButton;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    procedure MkDs18x20GetTemp(Sender: TObject);
    procedure MkDs18x20SessionActive(Sender: TObject);
    procedure MkDs18x20SessionError(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);

    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure Timer1Timer(Sender: TObject);
    procedure MkDs18x20GetSensorCount(Sender: TObject);
    procedure MkDs18x20StartCommand(Sender: TObject);
    procedure MkDs18x20StartRead(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;



implementation

{$R *.dfm}



procedure TForm1.Button7Click(Sender: TObject);
var
  po: Boolean;
  i: Integer;
begin


  if Button7.Tag = 0 then begin
    Button7.Tag := 1;
    MkDs18x20.ComPort := ComboBox1.Text;
    MkDs18x20.AdapterType := StrToIntDef( ComboBox2.Text, 1 );
    if MkDs18x20.DriverActive then begin
  //    MkDs18x20.TMEXGetTemp;
      MkDs18x20.TMEXGetDSCount;
      Panel1.Color := clAqua;
      Panel1.Caption := 'start';
      Button7.Caption := 'STOP';
    end else begin

      ShowMessage('Brak zainstalowanego sterownika MAXIM - TMEX micro LAN');
      Exit;
    end;
  end else begin
    Button7.Enabled := False;
    Button7.Tag := 0;
      Panel1.Color := clGreen;
      Panel1.Caption := 'stop';
      Button7.Caption := 'START';
      Timer1.Enabled := False;
      MkDs18x20.Close;
      Button7.Enabled := True;
      ListView1.Items.Clear;
  end;










//  MkDs18x20.ComPort := ComboBox1.Text;
//  if MkDs18x20.DriverActive then begin
//    MkDs18x20.TMEXGetDSCount;
//    Panel1.Color := clAqua;
//    Panel1.Caption := 'start';
//  end else begin
//
//    showmessage('Brak zainstalowanego sterownika MAXIM - TMEX micro LAN');
//
//  end;

end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items );
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  MkDs18x20.AdapterType := StrToIntDef( ComboBox2.Text, 1 );
  if ComboBox2.Text = '1' then begin
    Label12.Caption := 'DS9097E adapter on COM ports';
    Label13.Caption := 'ATB-USB-RS232 - 2 tranzystory';
  end;

  if ComboBox2.Text = '2' then begin
    Label12.Caption := 'DS1410E adapter on LPT ports';
    Label13.Caption := '';
  end;

  if ComboBox2.Text = '5' then begin
    Label12.Caption := 'DS9097U adapter on COM ports';
    Label13.Caption := 'DS2480B RS232/1wire converter';
  end;

  if ComboBox2.Text = '6' then begin
    Label12.Caption := 'DS1490 adapter on USB ports';
    Label13.Caption := 'USB/1wire converter';
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  frm: TfrmKomunikat;
begin
  Hide;
  frm := TfrmKomunikat.Create(Application);
  frm.Show;
  MkDs18x20.Close;

  frm.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  Panel1.Parent := StatusBar1;
  StatusBar1.Panels[0].Style := psOwnerDraw;

  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items );

end;

procedure TForm1.FormShow(Sender: TObject);
begin
StatusBar1.Panels[1].Text := MkDs18x20.DriverVer;
end;

procedure TForm1.MkDs18x20GetSensorCount(Sender: TObject);
begin
  Label3.Caption := IntToStr(MkDs18x20.FSensorCount);
  if MkDs18x20.FSensorCount=0 then begin
    Label3.Font.Color := clRed;
    ListView1.Clear;
  end else Label3.Font.Color := $00FF8000;

  Label5.Visible := False;

  Timer1.Enabled := True;
end;

procedure TForm1.MkDs18x20GetTemp(Sender: TObject);
var
  buf, port, desc, chip: String;
  i: Integer;
  lvItem: TListItem;
begin


  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;

  for i := 0 to MkDs18x20.FSensorCount - 1 do begin


    lvItem := ListView1.Items.Add;
    if MkDs18x20.sensor[i].name='DS18B20' then lvItem.ImageIndex := 0 else lvItem.ImageIndex := 2;
    lvItem.Caption := ' '+MkDs18x20.sensor[i].temp+' '+char(176)+'C';

    if MkDs18x20.sensor[i].name='DS2401' then begin
      lvItem.ImageIndex := 1;
      lvItem.Caption := 'Silicon Nr';
    end;

    lvItem.SubItems.Add(MkDs18x20.sensor[i].name);
    lvItem.SubItems.Add(MkDs18x20.sensor[i].romstr);

  end;
  ListView1.Items.EndUpdate;

  Timer1.Enabled := True;
  Panel1.Color := clGreen;
  Panel1.Caption := '';

end;

procedure TForm1.MkDs18x20SessionActive(Sender: TObject);
begin
StatusBar1.Panels[1].Text := 'Poczenie aktywne';
end;

procedure TForm1.MkDs18x20SessionError(Sender: TObject);
begin
  StatusBar1.Panels[1].Text := MkDs18x20.TMEXerror;
  Panel1.Color := clRed;
  Panel1.Caption := 'error';
  Timer1.Enabled := True;
end;

procedure TForm1.MkDs18x20StartCommand(Sender: TObject);
begin
  Panel1.Color := clYellow;
  Panel1.Caption := 'send cmd';
end;

procedure TForm1.MkDs18x20StartRead(Sender: TObject);
begin
  Panel1.Color := clLime;
  Panel1.Caption := 'odczyt';
end;

procedure TForm1.StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin
  with StatusBar.Canvas do
  begin
    case Panel.Index of
      0:
      begin
        Panel1.Top := rect.Top;// + 1;
        Panel1.Left := rect.Left + 1;
        Panel1.Width := rect.Right - rect.Left-3;// - 3 - 4;
        Panel1.Height := rect.Bottom - rect.Top;// - 2;
      end;
    end;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;

  if CheckBox1.Checked then begin
    Label5.Visible := True;
    MkDs18x20.TMEXGetDSCount;
    CheckBox1.Checked := False;
    Exit;
  end;

  MkDs18x20.TMEXGetTemp;

end;

end.
